#include "RdbInsert.h"
#include "Log.h"


void RdbInsert::CreateStmt(const String varPlaceHolder,
			   const int addSequence)
{
    ostrstream s;
    s << "insert into " << rel.RelName() << " (";
    int arity = rel.Arity();
    for( int i = 0 ; i < arity ; i++ ) {
	if( i > 0 ) s << ',';
	s << rel.ColName(i);
    }
    s << ") values (";
    for( i = 0 ; i < arity ; i++ ) {
	if( i > 0 ) s << ',';
	s << varPlaceHolder;
	if( addSequence ) s << i;
    }
    s << ')';
    statement = s;
    RDBLOG(database.DBLog(), "Insert stmt: "<<statement<<'\n');
}    


void RdbInsert::CreateStmt(const RdbItemList& bindings)
{
    ostrstream s;
    s << "insert into " << rel.RelName() << " (";
    int arity = rel.Arity();
    for( int i = 0 ; i < arity ; i++ ) {
	if( bindings[i].Type() != RdbItem::RDB_NULL ) {
	    if( i > 0 ) s << ',';
	    s << rel.ColName(i);
	}
    }
    s << ") values ";
    char sep = '(';
    for( i = 0 ; i < arity ; i++ ) {
	s << sep;
	switch( bindings[i].Type() ) {
	  case RdbItem::RDB_STRING:
	    s << '\'' << bindings[i] << '\'';
	    break;
	  case RdbItem::RDB_INT:
	  case RdbItem::RDB_REAL:
	    s << bindings[i];
	    break;
	  case RdbItem::RDB_NULL:
	    break;
	  default:
	    assert(0);
	}
	sep = ',';
    }
    s << ')';
    statement = s;
    RDBLOG(database.DBLog(), "Insert stmt: "<<statement<<'\n');
}


RdbError::ErrorCode RdbInsert::Insert(const RdbItemList& newTuple)
{
    database.SetFocus();
    return VInsert(newTuple);
}
