#include "RdbItem.h"


// should probably make some of these inline...

RdbItem::RdbItem( const RdbInt val )
{
    type = RDB_INT;
    intVal = val;
}

RdbItem::RdbItem( const RdbReal val )
{
    type = RDB_REAL;
    realVal = val;
}

RdbItem::RdbItem( const String& val )
{
    type = RDB_STRING;
    strPtr = new String(val);
}

RdbItem::RdbItem( const char* val )
{
    type = RDB_STRING;
    strPtr = new String(val);
}

RdbItem::RdbItem()
{
    type = RDB_NULL;
}

RdbItem::RdbItem( const RdbItem& other )
{
    type = RDB_NULL;
    *this = other;
}


RdbItem::~RdbItem()
{
    Cleanup();
}


void RdbItem::Cleanup()
{
    if( type == RDB_STRING ) {
	delete strPtr;
    }
    type = RDB_NULL;
}


RdbItem& RdbItem::operator =( const RdbItem& other )
{
    Cleanup();
    type = other.type;
    switch( type ) {
      case RDB_INT:
	intVal = other.intVal;
	break;
      case RDB_REAL:
	realVal = other.realVal;
	break;
      case RDB_STRING:
	strPtr = new String( *other.strPtr );
	break;
      case RDB_NULL:
	; // nada
    }
    return *this;
}

RdbItem::operator RdbInt() const
{
    switch(type) {
      case RDB_INT:
	return intVal;
      case RDB_REAL:
	return (RdbInt)realVal;
      case RDB_STRING:
	return *strPtr;
      default:
	assert(0);
    }
    return 0;
}

RdbItem::operator RdbReal() const
{
    switch( type ) {
      case RDB_INT:
	return intVal;
      case RDB_REAL:
	return realVal;
      case RDB_STRING:
	return *strPtr;
      default:
	assert(0);
    }
    return 0;
}

RdbItem::operator String() const
{
    switch( type ) {
      case RDB_STRING:
	return *strPtr;
      case RDB_INT:
	return String(intVal);
      case RDB_REAL:
	return String(realVal);
      default:
	assert(0);
    }
    return String("");
}

ostream& operator <<(ostream& outs, const RdbItem& item)
{
    switch( item.type ) {
      case RdbItem::RDB_INT:
	outs << item.intVal;
	break;
      case RdbItem::RDB_REAL:
	outs << item.realVal;
	break;
      case RdbItem::RDB_STRING:
	outs << *item.strPtr;
	break;
      case RdbItem::RDB_NULL:
	outs << "N/A";
	break;
    }
    return outs;
}

