
#include "RdbIngresSystem.h"
#include "RdbIngresQuery.h"
#include "RdbIngresInsert.h"
#include "RdbIngresDelete.h"


inline RdbIngresDatabase::RdbIngresDatabase(RdbIngresSystem& ingresSystem,
					    const String newDbName,
					    const String userid = String(),
					    const String password = String(),
					    const String serverName = String())
: RdbDatabase(newDbName, ingresSystem),
  system(ingresSystem)
{
    sessionId = nextSessionId++;
}


inline RdbIngresDatabase::~RdbIngresDatabase()
{
    Disconnect();
}


inline RdbQuery* RdbIngresDatabase::NewQuery(RdbJoin& joinInfo,
					     const BitVector& adorn)
{
    return new RdbIngresQuery(joinInfo, adorn);
}


inline RdbInsert* RdbIngresDatabase::NewInsert(RdbRelation& rel)
{
    return new RdbIngresInsert(rel);
}


inline RdbDelete* RdbIngresDatabase::NewDelete(RdbRelation& rel,
					       const BitVector& adorn)
{
    return new RdbIngresDelete(rel, adorn);
}


inline RdbIngresSystem& RdbIngresDatabase::System() const
{
    return system;
}


inline virtual void const* RdbIngresDatabase::Implementor() const
{
    return this;
}
