
#include "RdbSybaseSystem.h"
#include "RdbSybaseQuery.h"
#include "RdbSybaseInsert.h"
#include "RdbSybaseDelete.h"


inline RdbQuery* RdbSybaseDatabase::NewQuery(RdbJoin& joinInfo,
					     const BitVector& adorn)
{
    return new RdbSybaseQuery(joinInfo, adorn);
}


inline RdbInsert* RdbSybaseDatabase::NewInsert(RdbRelation& rel)
{
    return new RdbSybaseInsert(rel);
}


inline RdbDelete* RdbSybaseDatabase::NewDelete(RdbRelation& rel,
					       const BitVector& adorn)
{
    return new RdbSybaseDelete(rel, adorn);
}


inline RdbSybaseSystem& RdbSybaseDatabase::System() const
{
    return system;
}


inline void const* RdbSybaseDatabase::Implementor() const
{
    return this;
}
