// *************************************************************************
//  HashVal.C
// *************************************************************************

#include "HashVal.h"
#include "Debug.h"

//          Try both a simple hash as well as a better one
//#define   SIMPLE_HASH

// *************************************************************************
HashVal Cor_StrHash(const char *s)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    HashVal hash = 0;

    while (*s) {
#ifdef    SIMPLE_HASH
       hash += *s++;
#else
       hash = (hash << 1) ^ (hash >> 20) ^ *(s++);
#endif
    }

      // This will catch UnknownHashValue and VarHashValue
      // which are reserved for interal use.
    if (hash >= UnknownHashValue) {
        hash = 1;
    }

    return(hash);
}

//  Previously was
//  HashVal hash = 0;
//  for (n -= 1; n >= 0; n--) {
//      hash += *s++;
//  }
//  return(hash);

// *************************************************************************
