// *************************************************************************
//    Literal.C
// *************************************************************************

#include "Literal.h"

#include "ParserStruct.h"
#include "BuiltinSymbols.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
//    Creates a literal with the specifed predicate

Cor_Literal::Cor_Literal(Cor_ParserStruct *Cor_parserStruct,
    Cor_CArg& name, int arg_count)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    predicate = Cor_FindPredicate(Cor_parserStruct, name, arg_count);
    kind = COR_REGULAR;
    pred = name;
    base_pred = 0;
    negated = 0;

    args.set_count(arg_count);
    adorn.init(arg_count);

    arith_pred = 0;
    if ( name.equals(Cor_EquOpSymbol)
      || name.equals(Cor_NeqOpSymbol)
      || name.equals(Cor_LssOpSymbol)
      || name.equals(Cor_GrtOpSymbol)
      || name.equals(Cor_LeqOpSymbol)
      || name.equals(Cor_GeqOpSymbol) )
        arith_pred = 1;
}

// *************************************************************************
//    Function Behaviour :: NOTE: No predicate is specified. Otherwise
//    similar to previous function.  Warning: predicate field is NULL

Cor_Literal::Cor_Literal(int arg_count)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    predicate = NULL;
    kind = COR_REGULAR;
    base_pred = 0;
    negated = 0;
    arith_pred = 0;
    args.set_count(arg_count);
    adorn.init(arg_count);
}

// *************************************************************************
Cor_Literal::~Cor_Literal()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    // Predicates are being shared - don't delete them
}

// *************************************************************************

